<?php
namespace EpTest\Images;

use Ep\Images\ConfigProvider;
use EpTest\ContainerAwareTrait;
use Psr\Container\ContainerInterface;
use Zend\ConfigAggregator\ArrayProvider;
use Zend\ConfigAggregator\ConfigAggregator;

/**
 * Class ImagesAwareTrait
 *
 * @package EpTest\Images
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/images
 */
trait ImagesAwareTrait
{
    use ContainerAwareTrait {
        createContainer as __createContainer;
    }

    /**
     * @param array $config
     *
     * @return ContainerInterface
     */
    protected function createContainer(array $config = []): ContainerInterface
    {
        $config = (new ConfigAggregator([
            ConfigProvider::class,
            new ArrayProvider([
                'app' => [
                    'development' => true,
                ],

                'images' => [
                    'base_path' => __DIR__ . '/serve',
                ],
            ]),
            new ArrayProvider($config),
        ]))->getMergedConfig();

        return $this->__createContainer($config);
    }
}